;von SpionAtom August 2012
Data "Indes stieg der Geruch von dem sssen Mus hinauf an die Wand, wo die Fliegen in grosser Menge sassen, so dass sie herangelockt wurden und sich scharenweis darauf niederliessen. >Ei, wer hat euch eingeladen?< sprach das Schneiderlein und jagte die ungebetenen Gste fort. Die Fliegen aber, die kein Deutsch verstanden, liessen sich nicht abweisen, sondern kamen in immer grsserer Gesellschaft wieder. Da lief dem Schneiderlein endlich, wie man sagt, die Laus ber die Leber, es langte aus seiner Hlle nach einem Tuchlappen, und >wart, ich will es euch geben!< schlug es unbarmherzig drauf."
Data "Als es abzog und zhlte, so lagen nicht weniger als sieben vor ihm tot und streckten die Beine. >Bist du so ein Kerl?< sprach er und musste selbst seine Tapferkeit bewundern, >das soll die ganze Stadt erfahren.< Und in der Hast schnitt sich das Schneiderlein einen Grtel, nhte ihn und stickte mit grossen Buchstaben darauf >siebene auf einen Streich!<"
Const xr = 150,yr = 150,MAX_FLYS = 7,CS = 100,fps = 60
SeedRnd MilliSecs()
Graphics 4 * xr,4 * yr,0,2
Graphics xr,yr,0,3
AppTitle "Sieben auf einen Streich! Linksklick=zuschlagen   Rechtsklick=Neustarten"
fps_timer = CreateTimer(fps)

	img_catcher = CreateImage(CS,CS)
	SetBuffer ImageBuffer(img_catcher)
	Color 50,100,150
	Oval 0,0,20,20,0
	Oval CS - 20,0,20,20,0
	Oval 0,CS - 20,20,20,0
	Oval CS - 20,CS - 20,20,20,0
	Color 0,0,0
	Rect 9,0,CS - 20,CS
	Rect 0,9,CS,CS - 20
	Color 50,100,150
	For i = 9 To CS - 9 Step 10
		Rect 0,i,CS,1
		Rect i,0,1,CS
	Next
	Rect 9,0,CS - 19,CS,0
	Rect 0,9,CS,CS - 19,0


HidePointer

Type Fly
	Field x#,y#,vx#,vy#
	Field alive
End Type
Global F.Fly


Type Popup
	Field txt$
	Field startTime,duration
	Field x,y
End Type
Global P.Popup





	SetBuffer BackBuffer()
Read intro$,outro$
tl = StringWidth(intro$)
th = StringHeight("|")
tx# = xr
ende = False
;Intro


	Repeat

		Cls
		Color 255,255,0
		Text 50,10,"Sieben"
		Text 5,24,"auf einen Streich"
		Color 55,155,255
		Text tx,(yr - th) / 2,intro$
		tx = tx - 0.5
		If tx < -(tl + 100)  ende = True
		Flip(0)
		WaitTimer fps_timer
		k = GetKey()
		If k = 0  k = MouseDown(1) Or MouseDown(2)

	Until k > 0 Or ende
	FlushKeys
	FlushMouse


reset
Global rang = -1

	gameStarted = MilliSecs()
	Repeat
		mouse_x = MouseX()
		mouse_y = MouseY()
		If MouseHit(2)  reset


		If MouseHit(1) 
			hit = 0
			For F = Each Fly
				If F\alive And inRect(F\x,F\y,mouse_x - CS / 2,mouse_y - CS / 2,CS,CS) 
					hit = hit + 1
					F\alive = False
				End If
			Next

			If hit > rang  rang = hit

			P = New Popup
			P\txt = hit + " Treffer!"
			P\startTime = MilliSecs()
			P\duration = 1000
			P\x = mouse_x
			P\y = mouse_y
		End If


		Cls

		Color 32,32,32
		Text 0,yr - 16,((MilliSecs() - gameStarted) / 1000) + "s verschwendet"


		For F.Fly = Each Fly
			drawFly F
			moveFly F
		Next

		DrawImage img_catcher, mouse_x - CS / 2,mouse_y - CS / 2
		Color 50,100,150
		Rect mouse_x - 10,mouse_y + CS / 2,20,yr


		Color 55,255,55
		For P = Each Popup
			Text P\x - StringWidth(P\txt) / 2,P\y,P\txt
			P\y = P\y - 1
			If P\startTime + P\duration < MilliSecs() 
				Delete P
			End If
		Next


		Color 255,255,0
		Select rang
			Case -1
			Case 0
				Text 0,0,"Trottel (0)"
			Case 1
				Text 0,0,"Sniper (1)"
			Case 2
				Text 0,0,"Pechvogel (2)"
			Case 3
				Text 0,0,"Noob (3)"
			Case 4
				Text 0,0,"Lehrling (4)"
			Case 5
				Text 0,0,"kleines"
				Text 0,16,"Schneiderlein (5)"
			Case 6
				Text 0,0,"Schneiderlein (6)"
			Case 7
				Text 0,0,"Tapferes"
				Text 0,16,"Schneiderlein (7)"
		End Select


		Flip(0)
		WaitTimer fps_timer

	Until KeyDown(1) Or rang = 7
	If rang <> 7  End
	
;Outro
tl = StringWidth(outro$)
tx# = xr
gt = (MilliSecs() - gameStarted) / 1000
ende = False
	Repeat
		Cls

		For F.Fly = Each Fly
			drawFly F
		Next

		Color 32,32,32
		Text 0,yr - 16,gt + "s verschwendet"

		Color 255,255,0
		Text 50,10,"Sieben"
		Text 5,24,"auf einen Streich"
		Color 55,155,255
		Text tx,(yr - th) / 2,outro$
		tx = tx - 0.5
		If tx < -(tl + 100)  ende = True
		Flip(0)
		WaitTimer fps_timer


		k = GetKey()


	Until k > 0 Or ende
	End



Function reset()

	For F = Each Fly
		Delete F
	Next

	For i = 1 To MAX_FLYS
		F = New Fly
		F\x = Rand(0,xr)
		F\y = Rand(0,yr)
		F\vx = Sin(Rand(360)) * 2 * (100. / Rand(50,100))
		F\vy = Cos(Rand(360)) * 2 * (100. / Rand(50,100))
		F\alive = True
	Next

End Function

Function drawFly(F.Fly)
	r = 3
	w = 5
	Color 150,150,150
	Oval F\x - r,F\y - r,2 * r,2 * r
		Color 200,200,200
		If Rand(0,1 + ((Not F\alive) * 500)) = 0 
			Oval F\x - r - 2 * w,F\y - w,2 * w,2 * w,0
			Oval F\x + r,F\y - w,2 * w,2 * w,0
		Else
			Oval F\x - r - w,F\y - w,w,2 * w,0
			Oval F\x + r,F\y - w,w,2 * w,0
		End If
	

	If Not F\alive 
		Color 255,32 * (F\x Mod 2),32 * (F\y Mod 2)
			Oval F\x - F\vx * 3,F\y - F\vy * 3,10 + (F\x + F\y) Mod 20,5 + (F\x + F\y) Mod 10
		Color 255,32 * (F\y Mod 2),32 * (F\x Mod 2)
			Oval F\x - F\vx * 5,F\y + F\vy * 3,10 + (F\x + F\y) Mod 20,5 + (F\x + F\y) Mod 10
		Color 255,32 * (Abs(F\vx) Mod 2),32 * (Abs(F\vy) Mod 2)
			Oval F\x - ((F\x + F\y) Mod 20) / 2,F\y - (5 + (F\x + F\y) Mod 10) / 2,10 + (F\x + F\y) Mod 20,5 + (F\x + F\y) Mod 10

	End If
End Function

Function moveFly(F.Fly)

	If Not F\alive  Return

	shizzle_x = Rand(-1,1) * (1.0 / Rand(10))
	shizzle_y = Rand(-1,1) * (1.0 / Rand(10))
	If F\x + F\vx + shizzle_x < 0 Or F\x + F\vx + shizzle_x > xr 
		F\vx = -F\vx
	Else
		F\x = F\x + F\vx + shizzle_x
	End If

	If F\y + F\vy + shizzle_y < 0 Or F\y + F\vy + shizzle_y > yr 
		F\vy = -F\vy
	Else
		F\y = F\y + F\vy + shizzle_y
	End If

End Function

;Prft,ob sich die Maus in einem angegebenen Rechteck befindet
Function inRect(px,py,x,y,w,h)
	If px <= x  Return False
	If py <= y  Return False
	If px >= x + w  Return False
	If py >= y + h  Return False
	Return True	
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D