Strict
Framework brl.basic
Import brl.timer
Import brl.max2d
Import brl.d3d9max2d

Const GW=800, GH=600
AppTitle = "Hilf den Bremer Stadtmusikanten"
Graphics GW, GH
SetBlend ALPHABLEND
Global uhr, punkte, limit=20
Global weg_img:TImage
init_imges
Local timer:TTimer = CreateTimer(50)

Tier.esel.w = 120
Tier.esel.h = 50
Tier.esel.bein_h = 40
Tier.esel.x = GW/2
Tier.esel.y = GH-Tier.esel.h/2-Tier.esel.bein_h-10
Tier.esel.rgb = $999999
Tier.esel.erstelle_img

Tier.plus[0] = New Tier
Tier.plus[0].w = 100
Tier.plus[0].h = 40
Tier.plus[0].bein_h = 15
Tier.plus[0].x = GW/2
Tier.plus[0].y = Tier.esel.y-Tier.esel.h/2-Tier.plus[0].h/2-Tier.plus[0].bein_h
Tier.plus[0].rgb = $BB8800
Tier.plus[0].erstelle_img

Tier.plus[1] = New Tier
Tier.plus[1].w = 80
Tier.plus[1].h = 30
Tier.plus[1].bein_h = 10
Tier.plus[1].x = GW/2
Tier.plus[1].y = Tier.plus[0].y-Tier.plus[0].h/2-Tier.plus[1].bein_h-Tier.plus[1].h/2
Tier.plus[1].rgb = $010101
Tier.plus[1].erstelle_img

Tier.plus[2] = New Tier
Tier.plus[2].w = 40
Tier.plus[2].h = 40
Tier.plus[2].bein_h = 10
Tier.plus[2].x = GW/2
Tier.plus[2].y = Tier.plus[1].y-Tier.plus[1].h/2-Tier.plus[2].bein_h-Tier.plus[2].h/2
Tier.plus[2].rgb = $DD6644
Tier.plus[2].erstelle_img 0

SetClsColor 100,100,155
Repeat
	Cls
	If uhr = 0 Then
		limit:-1	
		If limit = 2 Or limit = 5 Or limit = 10 Then Tier.esel.upgrade
	EndIf	
	uhr = (uhr+1) Mod 360
	If uhr Mod 7 = MilliSecs() Mod 37 Then Fang.liste.addlast New Fang
	If uhr Mod 42 = 0 Then punkte:+Fang.ok+Zuschauer.ok
	If Zuschauer.count()<20 And Fang.ok>7 And uhr Mod 8 = MilliSecs() Mod (600-Fang.ok-Zuschauer.ok*5) Then Zuschauer.liste.addlast New Zuschauer
	SetScale 1.5, 1.5
	SetColor 255,255,255
	DrawText punkte+" PUNKTE", 0, 25
	DrawText "ZEIT " + (limit*360+359-uhr)/60, 0, 0
	DrawText Zuschauer.count()+" ZUSCHAUER", 0, 50
	SetScale 1, 1
	SetColor 255, 255, 255
	DrawImage weg_img, 0, GH-10
	Tier.esel.update
	Tier.esel.draw
	Fang.updateall
	Zuschauer.updateall
	Flip 0
	WaitTimer timer
Until AppTerminate() Or KeyHit(KEY_ESCAPE) Or (uhr = 0 And limit = 0)
Tier.esel.v = 0
Tier.esel.x = GW*2/3
FlushKeys
Tier.esel.update
Tier.esel.update
Tier.esel.update
Cls
Tier.esel.draw
SetScale 3,2
DrawText punkte+" PUNKTE", 50, 50
SetScale 1,1
DrawText "Druecke eine beliebige Taste...",50,GH-50
Flip
FlushKeys
Delay 200
WaitKey
End

Function init_imges()
	Local pix:TPixmap, p Ptr, i, b, x, y
	pix = CreatePixmap(GW, 10, PF_BGRA8888)
	p = Int Ptr PixmapPixelPtr(pix)
	For i = 0 Until 10*GW 
		b = Rand(0, $FF)
		p[i] = b | b Shl 8 | b Shl 16 | $FF000000
	Next
	weg_img = LoadImage(pix)
	
	SetColor 160, 100, 0
	DrawRect 50, 50, 30, 30
	SetColor 255, 220, 220
	DrawRect 55, 60, 25, 20
	SetColor 255, 70, 70
	DrawRect 40, 80, 50, 60
	SetColor 40, 40, 255
	DrawRect 50, 140, 25, 60
	SetColor 100, 0, 0
	DrawRect 50, 200, 30, 10
	SetColor 255,255,255
	
	Zuschauer.img = CreateImage(60, 160)
	GrabImage Zuschauer.img, 40, 50	
	SetImageHandle Zuschauer.img, 30, 160	
	Cls
	SetColor 255,255,0
	DrawOval 10,10,20,20
	GrabImage Fang.img, 10, 10
EndFunction

Type Tier
	Global esel:Tier = New Tier
	Global plus:Tier[3], plus_i
	Field x:Float, y:Float
	Field w, h, bein_h, rgb
	Field v:Float
	Field img:TImage
	Field darunter:Tier
	Field darueber:Tier
	Method erstelle_img(l=1)
		Cls
		SetColor rgb Shr 16 & $FF, rgb Shr 8 & $FF, rgb & $FF
		DrawRect x-w/2-w/3,y-h/2+2,w/3, h/2
		DrawRect x-w/2,y-h/2,w,h
		If l Then DrawRect x-w/2+5,y+h/2,10,bein_h
		DrawRect x+w/2-15,y+h/2,10,bein_h
		img=CreateImage(w+w/3,h+bein_h)
		GrabImage img,x-w/2-w/3,y-h/2	
		SetImageHandle img,w/2,h/2
	EndMethod	
	Method draw()
		If darueber Then darueber.draw
		SetColor 255,255,255
		DrawImage img, x, y
	EndMethod
	Method update()
		If darueber darueber.update
		If Not darunter Then
			If KeyDown(KEY_LEFT)
				If v>0.5 Then v:*.98 Else v:-0.04*(plus_i+1)	
				If v < -5 Then v = -5
			ElseIf KeyDown(KEY_RIGHT)
				If v<-0.5 Then v:*.98 Else v:+0.04*(plus_i+1)
				If v > 5 Then v = 5
			EndIf

			x:+v
			If x>GW+50 Then x = GW+50
			If x<-50 Then x = -50
		Else
			x=darunter.x-esel.v*6
		EndIf
	EndMethod
	Method upgrade()
		Local ziel:Tier = esel
		While ziel.darueber
			ziel = ziel.darueber
		Wend
		ziel.darueber = plus[plus_i]
		plus[plus_i].darunter = ziel
		plus_i:+1
	EndMethod
EndType

Type Fang
	Global liste:TList = New TList, img:TImage = CreateImage(20, 20), ok
	Field x:Float, y:Float
	Method New()
		x = Rand(100, GW-100)
	EndMethod
	Method update()
		Local tier:Tier
		SetColor 255, 255, 0
		DrawOval x-10, y-10, 20, 20
		y:+3
		tier = Tier.esel
		Repeat
			If ImagesCollide(tier.img, tier.x, tier.y, 0, img, x, y, 0) Then	
				ok:+(1+Zuschauer.count())*(Tier.plus_i+1)
				liste.remove Self
				Return
			EndIf
			If tier.darueber Then tier = tier.darueber Else Exit
		Forever
		If y > GH Then liste.remove Self
	EndMethod
	Function updateall()
		For Local f:Fang = EachIn liste;f.update;Next
	EndFunction
EndType

Type Zuschauer
	Global liste:TList = New TList, img:TImage, ok
	Field x, phase, fade
	Method New()
		x = Rand(0,160)
		If x>=80 Then x = GW+80-x
		phase = Rand(0, 359)
		fade = -40	
	EndMethod
	Function count()
		Local a
		For Local z:Zuschauer = EachIn liste
			If z.fade <= 0 Then a:+1
		Next	
		Return a
	EndFunction	
	Method update()
		SetColor 255,255,255
		If fade = 4 Then liste.remove Self;Return
		If fade > 0 Then fade:-4;SetAlpha fade/100.0
		If fade < 0 Then fade:+1

		If x>GW/2 Then SetScale -1, 1
		If fade < 0 Then
			If x<GW/2 Then DrawImage img, x+fade, GH-10 Else DrawImage img, x-fade, GH-10
		Else	
			DrawImage img, x, GH-20*Abs(Sin(uhr*4+phase))-10
		EndIf
		SetScale 1, 1
		SetAlpha 1
		If fade = 4 Then liste.remove Self;Return		
		If fade = 0 And ImagesCollide(Tier.esel.img, Tier.esel.x, Tier.esel.y, 0, img, x, GH, 0) Then
			ok:-1
			punkte:*0.9
			fade = 100
			Return
		EndIf
	EndMethod
	Function updateall()
		For Local z:Zuschauer=EachIn liste;z.update;Next
	EndFunction
EndType